## Script (Python) "getTagSize"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=tag,minSize=8,maxSize=16,thresholdsDict=None,tags=None,method='linear'
##title=
##

""" returns normalized size for a given tag """

from Products.CMFCore.utils import getToolByName
from math import pow 


catalog = getToolByName(context, 'portal_catalog')
utils = getToolByName(context, 'plone_utils')
tcetool = getToolByName(context, 'tag_cloud_explorer_tool')

friendly_types = utils.getUserFriendlyTypes()
allowed_states = tcetool.allowed_states

if not tags:
    tags = catalog.uniqueValuesFor('Subject')

query = {
         'portal_type': friendly_types,
         }
if allowed_states:
    query['review_state'] = allowed_states
    
tagWeight = len(catalog.searchResults(Subject=tag, **query))
if ((not tagWeight) or (not tags)):
    return None

if thresholdsDict:
    for o_min, o_max in thresholdsDict.keys():
        if ( (tagWeight >= o_min)and(tagWeight <= o_max)):
            return thresholdsDict[(o_min, o_max)]
    
# Get the min and max values
all_values = [len(catalog.searchResults(Subject=tag, **query)) for tag in tags]
maxWeight = max(all_values)
minWeight = min(all_values)


if method == 'linear': 
    thresholds = [ minWeight+i*((maxWeight - minWeight) / float(maxSize-minSize)) for i in range(0, (maxSize-minSize))]
elif method == 'exponential':
    thresholds = [pow(maxWeight - minWeight + 1, float(i) / float(maxSize-minSize)) for i in range(0, (maxSize-minSize))]
else: # no scaling
    return minSize
 
size = 0
for t in thresholds:
    if tagWeight <= t:
        break
    size += 1
return size+minSize
